{ rotinas de tratamento de funcoes do editor }
{ Autores: Marcelo Luis Pinheiro }
{ Orientador Academico: Jose' Antonio Borges }
{ Em 10/12/93 }

Unit Bibusca;

interface
uses
    DVcrt, Windows, DVWin, BibLer, sysUtils,
    Bibvars, Bibsom, Biblifun, bibloco, dvlenum;

Procedure palavraDir (falando: boolean);
Procedure palavraEsq (falando: boolean);
Procedure buscaRebusca;
Procedure AvancaNumber;
Procedure VoltaNumber;
Procedure buscaPalavraBG;
Procedure buscaDeNovoBG;
Procedure buscaPalavra;
Procedure buscaCadeia;
Procedure buscaNovamente;
Procedure buscaDeNovo;
Procedure buscaDeNovo1;

implementation

var
    sz: array [0..144] of char;

{-----------------------------}

Procedure palavraDir (falando: boolean);
var
    linha: string;
    tam: integer;
    c: char;
begin
    tam := length (texto [py]);
    linha := texto [py] + ' x';

    c := linha[px];
    if c <> ' ' then
        repeat
            px := px + 1;
            c := linha[px];
        until not (c in ['a'..'z', 'A'..'Z', '0'..'9', #128..#255]);

    if c = ' ' then
        repeat
            px := px + 1;
            c := linha[px];
        until c <> ' ';

    if px > tam+1 then
        begin
            px := tam+1;
            if falando then sintBip;
        end
    else
        if falando then sintClek;
end;

{--------------------------------------------------------}

Procedure palavraEsq (falando: boolean);
var
    linha: string;
    c: char;
begin
    linha := ' x' + texto [py];
    px := px + 2;

    repeat
        px := px - 1;
        if px <= length (linha) then
            c := linha[px]
        else
            c := ' ';
    until c <> ' ';

    repeat
        px := px - 1;
        c := linha[px];
    until not (c in ['a'..'z', 'A'..'Z', '0'..'9', #128..#255]);

    px := px - 1;

    if px <= 0 then
        begin
            px := 1;
            if falando then sintBip;
        end
    else
        if falando then {sintClek};

end;

{-----------------------------}

procedure maiuscula (var s: Linha);
var c: char;
    i: integer;
begin
    for i := 1 to length (s) do
        begin
            c := s[i];
            if c < #128 then
                c := upcase (c)
            else
                case c of
                    '': c := '';
                    '': c := '';
                    '': c := '';    { provisorio }
                    '' : c := '';    { provisorio }
                    '': c := '';    { provisorio }
                    '': c := '';    { provisorio }
                    '': c := '';    { provisorio }
                    '': c := '';    { provisorio }
                    '': c := '';
                    '': c := '';
                    '': c := '';    { provisorio }
                    'u': c := 'U';    { provisorio }
                    '': c := '';
                end;
            s[i] := c;
        end;
end;

{-----------------------------}

Procedure buscaRebusca;
var x : byte;
k, i: integer;
arquiBloco, s: string;
a: text;
    textoAProcurar, buscado: string;
    c: char;

label denovo;
begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    buscado := textoAProcurar;

ponteiro:=3;
  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    sintsom ('BVTXTPRC');
    sintsom ('BVPRCINI'); {' desde o incio da Bblia'}
    sintetiza (buscado);
    begin
    c := sintEdita (buscado, wherex, wherey, 255, true);
    buscado := maiuscAnsi (buscado);
    writeln;
sintclek;

    if buscado = '' then
    buscado := textoAProcurar;
            strPCopy (sz, buscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo('BVDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

    if buscado = '' then
        begin
buscado := textoAProcurar;
buscadenovo;
//                msgbaixo('BVDESIST', 'Operao cancelada');
            exit;
        end
else

  seek(arquivo,ponteiro +py-1);
Limite := tamanhoBiblia;

k:=-1;
i:=-1;
denovo:
if k = 50 then
begin
k:=k-50;
end;
k:=k+1;
i:=i+1;
            str (i, s);

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := x;
    atualizaporindice;
//                  letrecho;
gravaProcura;
if k = 50 then
sintbip;
goto denovo;
                end;
        end;

begin
arquiBloco := '0' + buscado + '.TXT';
  arquibloco :=limpa(  arquiBloco );

             assign (a, arquibloco);
             {$i-} reset (a); {$i+}
             If ioresult = 0 then
             begin
                 close (a);

begin
assign(a, arquibloco);
{$I-} append(a);{$I+}
If IOresult <> 0  Then
    begin
    exit;
    {$I-}close(a);{$I+}
    end;

if i = 1 then
begin
    writeln(a, '');
    writeln(a, ''+ s+ ' ocorrncia da palavra '+'"'+buscado+'"');
end;

if i > 1 then
begin
    writeln(a, '');
    writeln(a, ''+ s+ ' ocorrncias da palavra '+'"'+buscado+'"');
end;

end;
close(a);
end;
end;

                msgbaixo('BVBIP', 'Bip');

if i = 0 then
begin
                msgbaixo('BVNENHUM', 'Nenhuma ocorrncia da palavra:');
sintbip;
sintwriteln (' "' + buscado + '"');
sintbip;
end;

if i = 1 then
begin
                msgbaixo('BVUMA', 'Uma');
                msgbaixo('BVOCOPA1', ' ocorrncia da palavra:');
sintbip;
sintwriteln (' "' + buscado + '"');
sintbip;
end;

if i = 2 then
begin
                msgbaixo('BVDUAS', 'Duas');
                msgbaixo('BVOCOPAL', ' ocorrncias da palavra:');
sintbip;
sintwriteln (' "' + buscado + '"');
sintbip;
end;

if i > 2 then
begin
sintwriteint (i);
                msgbaixo('BVOCOPAL', ' ocorrncias da palavra:');
sintbip;
sintwriteln (' ' + buscado);
sintbip;
end;

if i > 0 then
begin
                msgbaixo('BVVERRES', 'Veja o resultado no arquivo: ');
sintwriteln ( '0' + buscado + '.TXT');
end;

        atualizaporindice;
falalivroatual1;
                  letrecho;
    salvaCurx := px;
    salvaCury := py;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
    px := salvaCurx;
    py := salvaCury;
{px:=x;}
exit;
end;
end;

{-----------------------------}

Procedure AvancaNumber;
var x : byte;
begin
  buscado := '';
  seek(arquivo,ponteiro +py);
Limite := tamanhoBiblia;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 2;
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px := 2;
                    exit;
                end;
        end;

        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=2;
exit;
end;

{-----------------------------}

Procedure VoltaNumber;
var x : byte;
begin
  buscado := '';
Limite := tamanhoBiblia-tamanhoBiblia-1;

  while filepos(arquivo)> limite+3  Do
    begin
ponteiro := ponteiro - 1;
  seek(arquivo,ponteiro);
            read(arquivo, linhateste);
            x := pos (buscado, linhateste);

            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 2;
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px := 2;
                    exit;
                end;
                end;

if (ponteiro = 3) and (py=1) then
ponteiro := ponteiro + 1
else
ponteiro := ponteiro + 2;

  seek(arquivo,ponteiro);
    msgbaixo('BVINIBIB', 'Incio da Bblia!');
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
if pontaux = 1 then
                    px :=2
else
                    px :=1;
exit;
end;

{-----------------------------}

Procedure buscaPalavraBG;
var x : byte;
    textoAProcurar, buscado: string;
    c: char;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    buscado := textoAProcurar;

  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    sintsom ('BVTXTPRC');
    sintetiza (buscado);
    begin
    c := sintEdita (buscado, wherex, wherey, 255, true);
    buscado := maiuscAnsi (buscado);
    writeln;
sintclek;

    if buscado = '' then
    buscado := textoAProcurar;
            strPCopy (sz, buscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo('BVDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

    if buscado = '' then
        begin
buscado := textoAProcurar;
buscadenovo;
//                msgbaixo('BVDESIST', 'Operao cancelada');
            exit;
        end
else

  seek(arquivo,ponteiro +py-1);
  gotoxy(10,8); write('Procurar no livro ou geral ? (L/G) : ');
  sintsom('BVNOLNOT'); {'no livro, ou geral?'}
    sintetiza (buscado);
  repeat resp :=upcase(readkey) until resp In['L','G', #$1B];
  If resp = #$1B  Then
    begin
    msgbaixo('BVDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
    exit;
    end;
{  sintcarac(resp);}
  If resp = 'G'  then Limite := tamanhoBiblia
    Else limite := indice[codlivro+1]-2;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('BVBIP', 'Bip');
{                    Sintsom('BVTXTENC');}
  sintsom('BVOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := x;
    atualizaporindice;
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=x;
gravaprocura;
                    exit;
                end;
        end;

                msgbaixo('BVBIP', 'Bip');
    msgbaixo('BVTXNENC','Texto nao  encontrado');
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=1;
exit;
end;
end;

{-----------------------------}

Procedure buscaDeNovoBG;
var  x: byte;
    textoAProcurar, buscado: string;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    buscado := textoAProcurar;

sintclek;
  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Procurar no livro ou geral ? (L/G) : ');
  sintsom('BVNOLNOT'); {'no livro, ou geral?'}
    sintetiza (buscado);
  repeat resp:=upcase(readkey) until resp In['L','G',#$1B];
  If resp = #$1B  then
    begin
    msgbaixo('BVDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
    exit;
    end;
  If resp='G'  Then limite := tamanhobiblia
    else limite := indice[codlivro+1]-2;
{  sintcarac(resp);}
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('BVBIP', 'Bip');
{                    sintsom('BVTXTENC');}
  sintsom('BVOK');
                    ponteiro := filepos(arquivo)-1;
                    px := x;py:=1;
        atualizaporindice;
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=x;
gravaprocura;
                    exit;
                end;
        end;

                msgbaixo('BVBIP', 'Bip');
    msgbaixo('BVTXNENC','Texto nao encontrado');
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
end;

{-----------------------------}

Procedure buscaPalavra;
var x : byte;
    textoAProcurar, buscado: string;
    c: char;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    buscado := textoAProcurar;

ponteiro:=3;
  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    sintsom ('BVTXTPRC');
    sintsom ('BVPRCINI'); {' desde o incio da Bblia'}
    sintetiza (buscado);
    begin
    c := sintEdita (buscado, wherex, wherey, 255, true);
    buscado := maiuscAnsi (buscado);
    writeln;
sintclek;

    if buscado = '' then
    buscado := textoAProcurar;
            strPCopy (sz, buscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo('BVDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

    if buscado = '' then
        begin
buscado := textoAProcurar;
buscadenovo;
//                msgbaixo('BVDESIST', 'Operao cancelada');
            exit;
        end
else

  seek(arquivo,ponteiro +py-1);
Limite := tamanhoBiblia;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('BVBIP', 'Bip');
{                    Sintsom('BVTXTENC');}
  sintsom('BVOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := x;
    atualizaporindice;
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=x;
gravaprocura;
                    exit;
                end;
        end;

                msgbaixo('BVBIP', 'Bip');
    msgbaixo('BVTXNENC','Texto nao  encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=1;
exit;
end;
end;

{-----------------------------}

Procedure buscaCadeia;
var x : byte;
begin
  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    sintsom ('BVTXTPRC');
  buscado :=maiuscansi(limpa( lelinha));
sintclek;
        if buscado = '' then
            begin
                msgbaixo('BVDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
            end;
  seek(arquivo,ponteiro +py-1);
Limite := TamanhoInfo;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('BVBIP', 'Bip');
{                    Sintsom('BVTXTENC');}
  sintsom('BVOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := x;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=x;
                    exit;
                end;
        end;

                msgbaixo('BVBIP', 'Bip');
    msgbaixo('BVTXNENC','Texto nao  encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=1;
exit;
end;

{-----------------------------}

Procedure buscaDeNovo;
var  x: byte;
    textoAProcurar, buscado: string;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    buscado := textoAProcurar;

sintclek;
limite := tamanhobiblia;
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('BVBIP', 'Bip');
{                    sintsom('BVTXTENC');}
  sintsom('BVOK');
                    ponteiro := filepos(arquivo)-1;
                    px := x;py:=1;
        atualizaporindice;
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=x;
gravaprocura;
                    exit;
                end;
        end;

                msgbaixo('BVBIP', 'Bip');
    msgbaixo('BVTXNENC','Texto nao encontrado');
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
end;

{-----------------------------}

Procedure buscaDeNovo1;
var  x: byte;
begin
sintclek;
limite := tamanhobiblia;
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('BVBIP', 'Bip');
{                    sintsom('BVTXTENC');}
  sintsom('BVOK');
                    ponteiro := filepos(arquivo)-1;
                    px := x;py:=1;
        atualizaporindice;
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=x;
                    exit;
                end;
        end;

                msgbaixo('BVBIP', 'Bip');
    msgbaixo('BVTXNENC','Texto nao encontrado');
falalivroatual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
end;

{-----------------------------}

Procedure buscaNovamente;
var  x: byte;
begin
sintclek;
limite := TamanhoInfo;
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('BVBIP', 'Bip');
{                    sintsom('BVTXTENC');}
  sintsom('BVOK');
                    ponteiro := filepos(arquivo)-1;
                    px := x;py:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=x;
                    exit;
                end;
        end;

                msgbaixo('BVBIP', 'Bip');
    msgbaixo('BVTXNENC','Texto nao encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
end;

begin
    buscado := '~';
end.
