{    Unidade das funcoes da Biblia    }
{    Autor : Marcelo Luis Pimentel Pinheiro    }
{    Rio de Janeiro, 07 de Abril de 1996}

Unit Bibfunc;

Interface

Uses DVCRT, WinDOWS, DVWin, bibsom, sysUtils,
    Bibvars, Biblifun, Leitura, Bibler, bibloco;

Procedure ProcuraCapitulo;
Procedure procuraTexto;
Procedure Informacoes;
Procedure Letudo;
Procedure Letudo1;
Procedure Letudo2;
Procedure Letudo3;
Procedure Letudo4;
Procedure Letudo5;
Procedure Letudo6;
Procedure Letudo7;
Procedure Letudo8;
Procedure Letudo9;
Procedure Letudo0;
Procedure LivroProverbi;
Procedure LivroSalm;
Procedure NovoTestamen;

Implementation

Procedure ProcuraCapitulo;
var x : byte;
Begin
  Limpabaixo;
  gotoxy(20, 8);
  write ('Procurar passagem :');
  sintsom ('BVPROCAP'); {'Procurar passagem'}
  gotoxy(11,24); write(barraselec);
  gotoxy(10, 11);
  write ('Selecione o livro desejado : ');
  sintsom ('BVSELLIV'); {'Selecione o livro desejado, e tecle ENTER'}
  codlivro :=SelecionaLivro(40, 11);
  If codlivro = 0  Then
    begin
    msgbaixo ('BVDESIST', 'Operao cancelada');
    exit;
    end;
  gotoxy(10, 13);
  write('Digite o nmero do captulo : ');
  sintsom('BVDIGCAP');
  capitulo:=Limpa (   leLinha );
  If capitulo = ''  Then
    begin
    msgbaixo('BVDESIST', 'Operao cancelada');
    exit;
    end;
    val(capitulo, capituloatual, erro);
  If capituloatual > Numerocap[codlivro]  then
    begin
    msgbaixo('BVCAPNAO', 'Captulo inexistente');
    exit;
    end;

  gotoxy(10,15);  write('Digite o nmero do versculo : ');
  sintsom('BVDIGVER');
  versiculo := limpa(  leLinha );
  If versiculo=''  then versiculo :='1';
 versiculo := ('' + versiculo);
  gotoxy(27, 18);
  textbackground(red);
  textcolor(white+blink);
  write (' ':21,'Abrindo a sua Bblia...');
  textbackground(blue);
  textcolor(lightgray);

  textoprocura := {maiuscansi(limpa(nomelivro^[codlivro]))+ }
         '-CAPITULO-'+capitulo;

  assign(arquivo, dadosDisco);
  {$I-} reset(arquivo); {$I+}
  If IOResult <> 0  Then
    begin
    msgbaixo('BVERRODT', 'Erro grave nos dados do sistema !');
    write(#7);
    delay (10);
    exit;
    end;
  achou := false;
  seek(arquivo, indice[codlivro]);
  While (not achou)and(filepos(arquivo)<indice[codlivro+1])  Do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura,linhateste)>0;{, 1, length(textoprocura));}
end;
  If not achou  Then
    begin
    msgbaixo('BVERRODT', 'Erro nos dados do sistema !');
    exit;
    end;
ponteiro := filepos(arquivo)-1;

{  If versiculo = '1'  Then inc(ponteiro,3)
    Else begin}
    while length(versiculo)<1  Do versiculo:=' '+versiculo;
    repeat
    read(arquivo, linhateste)
    Until (pos(versiculo, linhateste)>0)or(linhateste=limpeza);
{    end;}
  If linhateste<> limpeza  Then
    begin
    ponteiro:=filepos(arquivo)-1;
    sintsom('BVACHEI');
    end
    Else sintsom('BVSOCAP');

  py:=1;
px :=1;
  buscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
letrecho;
  ProcessaLeitura;
end;

{-----------------------------}

Procedure procuratexto;
var x : byte;
    sz: array [0..144] of char;
    textoAProcurar, buscado: string;
    c: char;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    buscado := textoAProcurar;

  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    sintsom ('BVTXTPRC');
    sintetiza (buscado);
    begin
    c := sintEdita (buscado, wherex, wherey, 255, true);
    buscado := maiuscAnsi (buscado);
gotoxy(10, 13);
write ('Digite o texto a procurar : ');
//sintclek;

    if buscado = '' then
    buscado := textoAProcurar;
            strPCopy (sz, buscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo('BVDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                exit;
end;

    if buscado = '' then
        begin
buscado := textoAProcurar;
                msgbaixo('BVDESIST', 'Operao cancelada');
            exit;
        end
else

  gotoxy(22, 16);
  textbackground(red);
  textcolor(white+blink);
  write ('Processando consulta em arquivos...');
  textbackground(blue);
  textcolor(lightgray);
  assign(arquivo, dadosDisco);
  {$I-} reset(arquivo); {$I+}
  If IOResult <> 0  Then
    begin
    msgbaixo('BVERRODT', 'Erro grave nos arquivos de dados');
    exit;
    end;
  achou := false;
  While (not achou)and(filepos(arquivo)<tamanhoBiblia)  Do
    begin
    read(arquivo, linhateste);
    linhateste := maiuscansi(limpa(linhateste));
    achou :=pos(buscado, linhateste) > 0;
            x := pos (buscado, linhateste);
end;
  If not achou  Then
    begin
                msgbaixo('BVBIP', 'Bip');
    msgbaixo('BVTXTNAO', 'Texto no encontrado');
    exit;
    end;

                msgbaixo('BVBIP', 'Bip');
{                    Sintsom('BVTXTENC');}
  sintsom('BVOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
    atualizaporindice;
falalivroatual1;
                    px :=x;
gravaprocura;
px:=x;
  ProcessaLeitura;
end;
end;

{-----------------------------}

Procedure informacoes;
label fecha;
begin
  pontaux :=0;
  assign(arquivo, dadosinfo);
{$I-}RESET(ARQUIVO);{$i+}
  iF ioRESULT <> 0  THEN
    begin
    msgbaixo('BVERRODT', 'Erro grave nos dados !');
    goto fecha;
    end;
  sintsom('BVLEINFO');
  ponteiro :=1;
    py:=1; px:=1;
    SalvaTamBib := TamanhoBiblia;
    SalvaTamInf := TamanhoInfo;
  TamanhoInfo :=SalvaTamInf;
    letrecho;
    leituraInfo;
close(arquivo);
  tamanhobiblia :=SalvaTamBib;
fecha :
ponteiro:=1;
end;

{-------------------------}

Procedure LeTudo;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

falaLivroAtual;
  sintsom('BVPODLER');
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo1;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca1;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo2;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca2;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo3;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca3;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo4;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca4;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo5;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca5;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo6;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca6;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo7;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca7;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo8;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca8;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo9;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca9;
  processaLeitura;
end;

{-------------------------}

Procedure LeTudo0;
begin
  pontaux :=0;
ponteiro :=indice[1];
  codlivro :=1;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

    VaiparaMarca0;
  processaLeitura;
end;

{-------------------------}

Procedure NovoTestamen;
begin
  pontaux :=0;
ponteiro :=indice[40];
  codlivro :=40;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

        msgbaixo('BVNOVTES', 'Novo Testamento!');
falaLivroAtual;
  sintsom('BVPODLER');
  processaLeitura;
end;

{-----------------------------}

Procedure LivroSalm;
begin
  pontaux :=0;
ponteiro :=indice[19];
  codlivro :=19;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

falaLivroAtual;
  sintsom('BVPODLER');
  processaLeitura;
end;

{-----------------------------}

Procedure LivroProverbi;
begin
  pontaux :=0;
ponteiro :=indice[20];
  codlivro :=20;
  capituloatual :=1;
  py:=1; px:=1;
  assign(arquivo, dadosdisco);
  {$i-} reset(arquivo);{$i+}
  If IOresult <> 0  then
    begin
    msgbaixo ('BVERRODT', 'Erro nos arquivos de dados.');
    exit;
    end;

falaLivroAtual;
  sintsom('BVPODLER');
  processaLeitura;
end;

end.
