{   Unidade trata de extracao de bloco da Biblia    }
{   Autor :  Marcelo Luis Pimentel Pinheiro     }

Unit Bibloco;

Interface

Uses WinDOWS, sysutils, DVCRT, DVWin, DVarq,
    BibVars, bibsom, bibler;

Procedure Gravabloco;
Procedure TratablocoInfo;
Procedure Tratabloco;
Procedure InicBloco;
Procedure BlocoLinha;
Procedure BlocoUma;
Procedure BlocoDuas;
Procedure BlocoTres;
Procedure BlocoQuatro;
Procedure BlocoCinco;
Procedure BlocoSeis;
Procedure BlocoSete;
Procedure BlocoOito;
Procedure BlocoNove;
Procedure BlocoDez;
Procedure BlocoVinte;
Procedure BlocoCapitulo;
Procedure BlocoLivro;
Procedure BlocoBiblia;
function testaExtensao (nomeArq: string): boolean;
Procedure AdicionaBloco;
procedure gravaProcura;

Implementation

var
    a : text;
   arquibloco : String;
    sz: array [0..144] of char;
c: char;
    nomedoarquivo, salvanome: string;

Procedure InicBloco;
begin
Inibloco :=0;
Fimbloco :=0;
end;

{-----------------------------}

Procedure BlocoLinha;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py);
    msgbaixo('BVBLKLIN', 'Bloco linha');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoUma;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+1;
    msgbaixo('BVBLKUMA', 'Uma Linha');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoDuas;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+2;
    msgbaixo('BVBLKDUA', 'Duas Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoTres;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+3;
    msgbaixo('BVBLKTRE', 'Tres Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoQuatro;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+4;
    msgbaixo('BVBLKQUA', 'Quatro Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoCinco;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+5;
    msgbaixo('BVBLKCIN', 'Cinco Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoSeis;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+6;
    msgbaixo('BVBLKSEI', 'Seis Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoSete;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+7;
    msgbaixo('BVBLKSET', 'Sete Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoOito;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+8;
    msgbaixo('BVBLKOIT', 'Oito Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoNove;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+9;
    msgbaixo('BVBLKNOV', 'Nove Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoDez;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+10;
    msgbaixo('BVBLKDEZ', 'Dez Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;


{-----------------------------}

Procedure BlocoVinte;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+19;
    msgbaixo('BVBLKVIN', 'Vinte Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}


Procedure BlocoCapitulo;
begin
    inibloco := py;
inibloco :=0;
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    ponteiro :=filepos(arquivo)-1;
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end;

      If (codlivro = 66) and (capituloatual =22) then
begin
capituloatual := capituloatual;
    inibloco := py;
  ponteiro := indice[codlivro];
inibloco :=ponteiro+ InicioUltimoCapitulo;
    fimbloco :=ponteiro+TamanhoApocalipse;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
  ponteiro := inibloco-7;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end
else

begin
  seek(arquivo, indice[codlivro]);
  inc(capituloatual);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;

      If codlivro <> 1 then
capituloatual := capituloatual-1
else

      If codlivro = 1 then
begin
  dec(capituloatual);
begin
if capituloatual =50 then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
  capituloatual :=50;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end
else
begin
    ponteiro :=filepos(arquivo)-3;
    fimbloco := ponteiro;
capituloatual := capituloatual;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;
end;
end;

      If (codlivro = 2) or (capituloatual =40) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 2;
  capituloatual :=40;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 3) or (capituloatual =27) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 3;
  capituloatual :=27;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 4) or (capituloatual =36) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 4;
  capituloatual :=36;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 5) or (capituloatual =34) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 5;
  capituloatual :=34;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 6) or (capituloatual =24) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 6;
  capituloatual :=24;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 7) or (capituloatual =21) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 7;
  capituloatual :=21;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 8) or (capituloatual =4) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 8;
  capituloatual :=4;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 9) or (capituloatual =31) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 9;
  capituloatual :=31;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 10) or (capituloatual =24) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 10;
  capituloatual :=24;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 11) or (capituloatual =22) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 11;
  capituloatual :=22;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 12) or (capituloatual =25) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 12;
  capituloatual :=25;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 13) or (capituloatual =29) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 13;
  capituloatual :=29;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 14) or (capituloatual =36) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 14;
  capituloatual :=36;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 15) or (capituloatual =10) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 15;
  capituloatual :=10;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 16) or (capituloatual =13) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 16;
  capituloatual :=13;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 17) or (capituloatual =10) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 17;
  capituloatual :=10;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 18) or (capituloatual =42) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 18;
  capituloatual :=42;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 20) or (capituloatual =31) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 20;
  capituloatual :=31;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 21) or (capituloatual =12) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 21;
  capituloatual :=12;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 22) or (capituloatual =8) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 22;
  capituloatual :=8;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 23) or (capituloatual =66) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 23;
  capituloatual :=66;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 24) or (capituloatual =52) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 24;
  capituloatual :=52;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 25) or (capituloatual =5) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 25;
  capituloatual :=5;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 26) or (capituloatual =48) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 26;
  capituloatual :=48;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 27) or (capituloatual =12) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 27;
  capituloatual :=12;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 28) or (capituloatual =14) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 28;
  capituloatual :=14;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 29) or (capituloatual =3) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 29;
  capituloatual :=3;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 30) or (capituloatual =9) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 30;
  capituloatual :=9;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 31) or (capituloatual =1) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 31;
  capituloatual :=1;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 32) or (capituloatual =4) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 32;
  capituloatual :=4;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 33) or (capituloatual =6) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 33;
  capituloatual :=6;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 34) or (capituloatual =3) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 34;
  capituloatual :=3;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 35) or (capituloatual =3) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 35;
  capituloatual :=3;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 36) or (capituloatual =3) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 36;
  capituloatual :=3;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 37) or (capituloatual =2) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 37;
  capituloatual :=2;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 38) or (capituloatual =14) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 38;
  capituloatual :=14;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 39) or (capituloatual =4) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 39;
  capituloatual :=4;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 40) or (capituloatual =28) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 40;
  capituloatual :=28;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 41) or (capituloatual =16) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 41;
  capituloatual :=16;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 42) or (capituloatual =24) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 42;
  capituloatual :=24;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 43) or (capituloatual =21) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 43;
  capituloatual :=21;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 44) or (capituloatual =28) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 44;
  capituloatual :=28;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 45) or (capituloatual =16) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 45;
  capituloatual :=16;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 46) or (capituloatual =16) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 46;
  capituloatual :=16;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 47) or (capituloatual =13) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 47;
  capituloatual :=13;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 48) or (capituloatual =6) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 48;
  capituloatual :=6;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 49) or (capituloatual =6) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 49;
  capituloatual :=6;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 50) or (capituloatual =4) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 50;
  capituloatual :=4;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 51) or (capituloatual =4) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 51;
  capituloatual :=4;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 52) or (capituloatual =5) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 52;
  capituloatual :=5;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 53) or (capituloatual =3) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 53;
  capituloatual :=3;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 54) or (capituloatual =6) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 54;
  capituloatual :=6;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 55) or (capituloatual =4) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 55;
  capituloatual :=4;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 56) or (capituloatual =3) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 56;
  capituloatual :=3;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 57) or (capituloatual =1) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 57;
  capituloatual :=1;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 58) or (capituloatual =13) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 58;
  capituloatual :=13;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 59) or (capituloatual =5) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 59;
  capituloatual :=5;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 60) or (capituloatual =5) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 60;
  capituloatual :=5;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 61) or (capituloatual =3) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 61;
  capituloatual :=3;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 62) or (capituloatual =5) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 62;
  capituloatual :=5;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 63) or (capituloatual =1) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 63;
  capituloatual :=1;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 64) or (capituloatual =1) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 64;
  capituloatual :=1;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

      If (codlivro = 65) or (capituloatual =1) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
codlivro := 65;
  capituloatual :=1;
  py:=1; px:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

begin
    ponteiro :=filepos(arquivo)-3;
    fimbloco := ponteiro;
    msgbaixo('BVBLKCAP', 'Bloco Captulo');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
exit;
end;

end;
end;

{-----------------------------}

Procedure BlocoLivro;
begin
    inibloco := py;
inibloco := 0;

    capituloatual := numerocap[codlivro] ;
  ponteiro := indice[codlivro]+1;
    capituloatual := 1;
    inibloco :=ponteiro;
    titulolerinibloco := tituloler;

begin
      If codlivro = 66  then
begin
  ponteiro := indice[codlivro];
    fimbloco :=ponteiro+TamanhoApocalipse;
end
else
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
end;
end;

    msgbaixo('BVBLKLIV', 'Bloco Livro');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

{-----------------------------}

Procedure BlocoBiblia;
begin
    inibloco := py;
inibloco := 0;

    capituloatual := numerocap[1] ;
  ponteiro := indice[1]+1;
    capituloatual := 1;
    inibloco :=ponteiro;
    titulolerinibloco := tituloler;

      codlivro := 1;
  ponteiro := indice[66];
    fimbloco :=ponteiro+TamanhoApocalipse;

    msgbaixo('BVBLKBIB', 'Bloco Bblia');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

{--------------------------------------------------------}

procedure falaTamanhoArq (tam: longint);
var
    medida: string;
    decimal: integer;
begin

    if tam >= 1024*1024 then
        begin
            medida := 'Mb';
            tam := tam div 1024;
            tam := tam div 1024;
        end;

begin
    if tam >= 65536 then
        begin
            medida := 'K';
            decimal := tam mod 1024;
            tam := tam div 1024;
            if decimal > 512 then tam := tam + 1;
        end;
        end;

if (medida <> 'Mb') and
(medida <> 'K') then
medida := 'bytes';

//    fala ('EDTOTAL'); {'Total: '}
    if tam = 0 then
        sintCarac ('0')    // corrige erro no sintetizador L&H
    else
        sintWrite (intToStr (tam) + medida);
end;

{--------------------------------------------------------}
{                mostra dados de arquivo
{--------------------------------------------------------}

procedure mostraDadosArq (arquibloco: string);
const
    tabDias: array [1..7] of string =
        ('Domingo', 'Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sbado');
var
    srec: TSearchRec;
begin
    sintWriteln (arquibloco);
    if FindFirst(arquibloco, faAnyFile, srec) <> 0 then
        begin
            fala ('EDINDISP');   {'Dado no disponvel'}
            exit;
        end;

    if (fileGetAttr (srec.FindData.cFileName) and faReadOnly) <> 0 then
         fala ('EDPRO');    { Protegido }

    falaTamanhoArq (srec.Size);
    writeln;

//    fala ('EDDATCRI');
sintWriteln (tabDias [dayOfWeek (FileDateToDateTime(srec.Time))]
        + ' ' + dateToStr (FileDateToDateTime(srec.Time))
        + ' ' + timeToStr (FileDateToDateTime(srec.Time)));
    writeln;

    findClose (srec);
end;

{--------------------------------------------------------}

Procedure GravaBloco;
var
    resp, c2: char;
    cor: integer;
    novoNome: string;

label inicio, fechaArq;
begin
  gotoxy(2,8); write(limpeza);
gotoxy(10, 8);

Inicio :
    nomeArquivo := sintAmbiente ('EDIVOX', 'NOMEDOARQUIVO');
    if nomeArquivo = '' then
        begin
            nomeArquivo := '';
        end;

    arquibloco := nomeArquivo;
  write ('Qual o nome do arquivo : ');
  sintsom ('BVQUEARQ');
    begin
    sintetiza (arquibloco);
    c := sintEdita (arquibloco, wherex, wherey, 255, true);
            arquibloco := compactaLinha (arquibloco);
    writeln;

    if arquibloco = '' then
    arquibloco := nomeArquivo;
            strPCopy (sz, arquibloco);
            writePrivateProfileString('EDIVOX', 'NOMEDOARQUIVO',     sz, 'DOSVOX.INI');

    if c = ESC then
                begin
    msgbaixo ('BVDESIST', 'Operao cancelada');
                    exit;
                end;

    if arquibloco = '' then
        begin
    msgbaixo ('BVDESIST', 'Operao cancelada');
            exit;
        end;

    if (c = baix) or (c = cima) or (c = F9) then
begin
            arquibloco := obtemNomeArq (15);
            arquibloco := compactaLinha (arquibloco);

            if arquibloco = '' then
                begin
    msgbaixo ('BVDESIST', 'Operao cancelada');
                    exit;
                end;

    if arquibloco = '' then
    arquibloco := nomeArquivo;
            strPCopy (sz, arquibloco);
            writePrivateProfileString('EDIVOX', 'NOMEDOARQUIVO',     sz, 'DOSVOX.INI');

                end;

             assign (a, arquibloco);
             {$i-} reset (a); {$i+}
             If ioresult = 0 then
             begin
                 close (a);
                 msgbaixo ('BVREESCR', 'Quer reescrever arquivo?');
            sintLeTecla (resp, c2);

                 if upcase (resp) = #0 then
                begin
                    if c2 = F1 then
                        begin
                            cor := textAttr;
                            textColor (yellow);
//                            fala ('EDDARQNV'); {'Dados do novo arquivo'}
                            mostraDadosArq (arquibloco);
//                            fala ('EDDARQEX'); {'Dados do arquivo existente'}
                            mostraDadosArq (novoNome);
//                            sintBip; sintBip;
                            textAttr := cor;
                        end;
                    goto inicio;
                end;

                 if upcase (resp) <> 'S' then
                      begin
                          msgbaixo ('BVESCCAN', 'Gravao de arquivocancelada');
                          goto inicio;
                      end;
         end;
//    end;

    assign (a, arquibloco);
    {$i-} rewrite (a); {$I+}
    if ioresult <> 0 then
        begin
    msgbaixo('BVNOMINV', 'Nome de arquivo invlido');
            arquibloco := '';
            goto inicio;
        end;

begin
numerocap[codlivro] := (ponteiro + py -1);
  seek(arquivo, numerocap[codlivro]);
   writeln(a, '' +titulolerinibloco);
end;

seek(arquivo, inibloco);
While filepos(arquivo)<= fimbloco  Do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, linhateste);
end;
  close(a);
{seek(arquivo, ponteiro);}
  msgbaixo ('BVARQGV', 'OK, arquivo gravado');
    arquibloco := salvaNome;
end;
end;

{-----------------------------}

function testaExtensao (nomeArq: string): boolean;
begin

    extPadrao := sintAmbiente ('EDIVOX', 'EXTENSAOPADRAO');
    if extPadrao = '' then
        begin
            extPadrao := '';
            strPCopy (sz, extPadrao);
            writePrivateProfileString('EDIVOX', 'EXTENSAOPADRAO',     sz, 'DOSVOX.INI');
        end;

    while (pos ('\', nomeArq) <> 0) and (nomeArq <> '') do
        delete (nomeArq, 1, pos ('\', nomearq));
    while (pos ('/', nomeArq) <> 0) and (nomeArq <> '') do
        delete (nomeArq, 1, pos ('/', nomearq));

    if pos ('.', nomeArq) <> 0 then
        testaExtensao := true
    else
        testaExtensao := false;
end;

{-----------------------------}

Procedure adicionabloco;

Label Inicio, fecha, fim;
begin
  gotoxy(2,8); write(limpeza);
gotoxy(10, 8);

    nomedoarquivo := sintAmbiente ('EDIVOX', 'NOMEDOARQUIVO');
    if nomedoarquivo = '' then
        begin
            nomedoarquivo := '';
        end;

    salvanome := arquibloco;
    arquibloco := nomedoarquivo;
Inicio :
  write ('Qual o arquivo a aionar : ');
  sintsom('BVQUEADC');
    sintetiza (arquibloco);
    c := sintEdita (arquibloco, wherex, wherey, 255, true);
            nomearquivo := compactaLinha (nomearquivo);
    writeln;

    if arquibloco = '' then
    arquibloco := nomedoarquivo;
            strPCopy (sz, arquibloco);
            writePrivateProfileString('EDIVOX', 'NOMEDOARQUIVO',     sz, 'DOSVOX.INI');

    if c = ESC then
                begin
    msgbaixo ('BVDESIST', 'Operao cancelada');
            goto fim;
                end;

    if arquibloco = '' then
    begin
    msgbaixo('BVDESIST', 'Operacao cancelada');
            goto fim;
        end;

    if (c = baix) or (c = cima) or (c = F9) then
begin
            arquibloco := obtemNomeArq (15);
            nomearquivo := compactaLinha (nomearquivo);

            if arquibloco = '' then
                begin
    msgbaixo ('BVDESIST', 'Operao cancelada');
                    exit;
                end;

    if arquibloco = '' then
    arquibloco := nomedoarquivo;
            strPCopy (sz, arquibloco);
            writePrivateProfileString('EDIVOX', 'NOMEDOARQUIVO',     sz, 'DOSVOX.INI');

                end;

    if not testaExtensao (arquibloco) then
        begin
            assign (a, arquibloco);
            {$i-} reset (a); {$i+}
            if ioresult = 0 then
                {$i-} close (a) {$i+}
            else
               if extPadrao <> '' then
    begin
                arquibloco := arquibloco + '.' + extPadrao;
    end
    else
                arquibloco := arquibloco;
        end;

assign(a, arquibloco);
{$I-} append(a);{$I+}
If IOresult <> 0  Then
    begin
    msgbaixo('BVNOMINV', 'Nome de arquivo invlido');
            goto inicio;
    end;

begin
  atualizaPorIndice;
numerocap[codlivro] := (ponteiro + py -1);
  seek(arquivo, numerocap[codlivro]);
    writeln(a, '');
    writeln(a, '' + tituloler);
end;

seek(arquivo, inibloco);
while filepos(arquivo)<= fimbloco  do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, linhateste);
    end;

fecha:
    {$I-}  close (a);  {$I+}
    if ioresult = 0 then
msgbaixo('BVARQADC', 'OK, arquivo adicionado');

fim:
    arquibloco := salvaNome;
End;

{-----------------------------}

procedure gravaProcura;
var fori:Byte;
    textoAProcurar, buscado: string;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    buscado := textoAProcurar;


        if gravaAsProcuras or (tecla = F12) then
begin
begin
pontaux:= ponteiro ;
If pontaux < 0  then pontaux:=0;
   seek(arquivo, pontaux);
    ponteiro := pontaux;
for fori := 1 to 11 do
  read(arquivo, texto[fori]);
end;

    inibloco := py;
inibloco :=0;
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    ponteiro :=filepos(arquivo)-1;
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end;

begin
    ponteiro :=filepos(arquivo)-1;
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end;

      If (codlivro = 66) and (capituloatual =22) then
begin
capituloatual := capituloatual-1;
    inibloco := py;
end;

begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;

begin
    ponteiro :=filepos(arquivo)-1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
    fimbloco := ponteiro;
end;

begin
arquiBloco := '0' + buscado + '.TXT';
  arquibloco :=limpa(  arquiBloco );

             assign (a, arquibloco);
             {$i-} reset (a); {$i+}
             If ioresult = 0 then
             begin
                 close (a);

begin
assign(a, arquibloco);
{$I-} append(a);{$I+}
If IOresult <> 0  Then
    begin
    exit;
    {$I-}close(a);{$I+}
    end;

seek(arquivo, inibloco);
while filepos(arquivo)<= fimbloco  do
    begin
    read(arquivo, linhateste);
    writeln(a, '');
    linhateste := trim (linhateste);
    writeln(a, '' + linhateste + ' "' + buscado + '"');
    end;
close(a);
end;
end
else
Begin
             assign (a, arquibloco);
{$I-} rewrite(a);{$I+}
If IOresult <> 0  Then
    begin
    {$I-} close(a){$I+};
    exit;
    end;

seek(arquivo, inibloco);
While filepos(arquivo)<= fimbloco  Do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, '' + linhateste + ' "' + buscado + '"');
end;
  close(a);
end;
end;
end;
ponteiro := pontaux;
letrecho;

begin
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py)-1;
    end;
    end;

begin
    fimbloco := ponteiro + pred(py)+3;
    end;
    end;

begin
arquiBloco := '0' + buscado + '.TXT';
  arquibloco :=limpa(  arquiBloco );

             assign (a, arquibloco);
             {$i-} reset (a); {$i+}
             If ioresult = 0 then
             begin
                 close (a);

begin
assign(a, arquibloco);
{$I-} append(a);{$I+}
If IOresult <> 0  Then
    begin
    exit;
    {$I-}close(a);{$I+}
    end;

seek(arquivo, inibloco);
while filepos(arquivo)<= fimbloco  do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, linhateste);
    end;
close(a);
end;
end
else
Begin
             assign (a, arquibloco);
{$I-} rewrite(a);{$I+}
If IOresult <> 0  Then
    begin
    {$I-} close(a){$I+};
    exit;
    end;

seek(arquivo, fimbloco);
While filepos(arquivo)<= fimbloco  Do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, linhateste);
end;
  close(a);
end;
end;
end;
end
        else
//            sintBip;
end;

{-----------------------------}

Procedure TratablocoInfo;
var c : char;
begin
gotoxy(2, 8); write(limpeza);
  gotoxy(10,8);
  write ('Comando de bloco : ');
  sintsom('BVCOMBLO');
c := readkey;

Case UPcase(c) Of
'I' : begin
    inibloco :=ponteiro + pred(py);
    write('Inicio do bloco');
    sintsom('BVINIBLO');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;

'F' : begin
    fimbloco := ponteiro + pred(py);
    write('Fim do bloco');
    sintsom('BVFIMBLO');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;

'A' : Adicionabloco;
'G' : GravaBloco;

else
             begin
    msgbaixo('BVDESIST', 'Operao cancelada');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end

end;
end;

{-----------------------------}

Procedure Tratabloco;
var c : char;
begin
gotoxy(2, 8); write(limpeza);
  gotoxy(10,8);
  write ('Comando de bloco : ');
  sintsom('BVCOMBLO');
c := readkey;

Case UPcase(c) Of

#27:
    begin
    msgbaixo('BVDESIST', 'Operao cancelada');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

'I' : begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-CAPITULO-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
    titulolerinibloco := tituloler;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    titulolerinibloco := tituloler;
    write('Inicio do bloco');
    sintsom('BVINIBLO');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
end;

'F' : begin
    fimbloco := ponteiro + pred(py);
    write('Fim do bloco');
    sintsom('BVFIMBLO');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;

'K' : begin
BlocoLinha;
    write('Bloco Linha');
end;

'1' : begin
BlocoUma;
    write('Uma Linha');
end;

'2' : begin
BlocoDuas;
    write('Duas Linhas');
end;

'3' : begin
BlocoTres;
    write('Trs Linhas');
end;

'4' : begin
BlocoQuatro;
    write('Quatro Linhas');
end;

'5' : begin
BlocoCinco;
    write('Cinco Linhas');
end;

'6' : begin
BlocoSeis;
    write('Seis Linhas');
end;

'7' : begin
BlocoSete;
    write('Sete Linhas');
end;

'8' : begin
BlocoOito;
    write('Oito Linhas');
end;

'9' : begin
BlocoNove;
    write('Nove Linhas');
end;

'D' : begin
BlocoDez;
    write('Bloco Bloco');
end;

'V' : begin
BlocoVinte;
    write('Bloco Maior');
end;

'B', 'T' : begin
BlocoBiblia;
    write('Bloco Bblia');
end;

'C' : begin
BlocoCapitulo;
    write('Bloco Capitulo');
end;

'L' : begin
BlocoLivro;
    write('Bloco Livro');
end;

'A' : Adicionabloco;

'G' : GravaBloco;


else
             begin
    msgbaixo('BVDESIST', 'Operao cancelada');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end

end;
end;

end.
