Unit Leitura;

Interface

uses DVHora,
    DVCRT, WinDOWS, sysUtils, Bibsom, DVWin,
    Bibvars, Biblifun, Bibloco, bibler,
    Bibusca, winprocs, wintypes, DVLenum;

Procedure ProcessaLeitura;
Procedure LeituraInfo;

Implementation
var lendoContinuo, iniciaLeitura: boolean;


procedure paramSintese;
var
    c, c2: char;
label fim;
begin
limpabaixo;
  gotoxy(15, 8); write('Modificando a fala:');
  gotoxy(10, 13); write('Qual a velocidade ? De 1 a 5: ');
  sintsom('BVVELOC');
    sintLeTecla (c, c2);
    writeln;
    if c in ['1'..'5'] then
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('BIBLIVOX', 'DIRBIBLIVOX'));
end;

fim:
//  sintsom('BVOK');
end;

{-----------------------------}

Procedure FalaVersao;
var s1: string;

begin
    s1 := sintAmbiente ('BIBLIVOX', 'BIBATU');
    if s1 = 'A' then
    begin
    msgbaixo ('BVVER_A', 'A - Verso em Portugus: Almeida Revista e Atualizada (ARA)');
    end;

    if s1 = 'B' then
    begin
    msgbaixo ('BVVER_B', 'B - Bblia na Linguagem de Hoje (BLH)');
    end;

    if s1 = 'C' then
    begin
    msgbaixo ('BVVER_C', 'C - Verso em Portugus: Almeida Revista e Corrigida(ARC)');
    end;

    if s1 = 'D' then
    begin
    msgbaixo ('BVVER_D', 'D - Verso em Portugus: Almeida Corrigida Fiel (ACF)');
    end;

    if s1 = 'E' then
    begin
    msgbaixo ('BVVER_E', 'E - Verso em Espanhol: Reina Valera 60 (RV60)');
    end;

    if s1 = 'F' then
    begin
    msgbaixo ('BVVER_F', 'F - Verso em Francs: Louis Segond (LSG)');
    end;

    if s1 = 'G' then
    begin
    msgbaixo ('BVVER_G', 'G - Verso em Grego: AT- Moderna Verso e NT- Verso WH');
    end;

    if s1 = 'H' then
    begin
    msgbaixo ('BVVER_H', 'H - Antigo Testamento em Hebraico (NT- ARA)');
    end;

    if s1 = 'I' then
    begin
    msgbaixo ('BVVER_I', 'I - Verso em Italiano: Congrezo Episcopale Italiano (CEI)');
    end;

    if s1 = 'J' then
    begin
    msgbaixo ('BVVER_J', 'J - Verso em Espanhol: Reina Valera 2000 (RV20)');
    end;

    if s1 = 'K' then
    begin
    msgbaixo ('BVVER_K', 'K - Verso em Ingls: King James Version (KJV)');
    end;

    if s1 = 'L' then
    begin
    msgbaixo ('BVVER_L', 'L - Verso em Alemo: Martin Luther Bibel 1545 (LUTHER)');
    end;

    if s1 = 'N' then
    begin
    msgbaixo ('BVVER_N', 'N - Verso em Ingls com Strong numbers: King James Version (KJV)');
    end;

    if s1 = 'R' then
    begin
    msgbaixo ('BVVER_R', 'R - Verso em Portugus: Almeida Revista e Corrigida (ARC1)');
    end;

    if s1 = 'S' then
    begin
    msgbaixo ('BVVER_S', 'S - Septuaginta e NT grego para estudo com Dicionrio Info');
    end;

    if s1 = 'T' then
    begin
    msgbaixo ('BVVER_T', 'T- Traduo do Novo Mundo das Escrituras Sagradas');
    end;

    if s1 = 'V' then
    begin
    msgbaixo ('BVVER_V', 'V- Verso em Latin: Vulgata Latina');
    end;

    if s1 = 'X' then
    begin
    msgbaixo ('BVVER_X', 'X- Verso em Esperanto');
    end;

    end;

{-----------------------------}

procedure jogaAreaTransf (falando: boolean);
var
    p: PChar;
textoClip: Linha;
    pos, tam: integer;
    tamAloc: integer;
begin
    if (inibloco <= 0) or (fimbloco < inibloco) then
        sintsom ('BVBLKINV')
    else
        begin
            getmem (p, tamAloc);
            pos := 0;

            tam := length(tituloler);
                    move (tituloler[1], p[pos], tam);
pos := tam;
            p[pos] := #$0D;
            p[pos+1] := #$0A;
            pos := pos + 2;

seek(arquivo, inibloco);
While filepos(arquivo)<= fimbloco  Do
    begin
    read(arquivo, textoClip);
    textoClip := trim (textoClip);
    tam := length(textoClip);
                    if (longint (pos) + tam + 2) > tamAloc then   // nunca deve acontecer isso
                        begin
                            sintsom ('BVCOPTRU');   {cpia truncada}
                            break;
                        end;

                    move (textoClip[1], p[pos], tam);
                    pos := pos + tam;
                    p[pos]   := #$0d;
                    p[pos+1] := #$0a;
                    pos := pos + 2;
                end;

            p[pos] := #$0;

            putClipboard (p);
seek(arquivo, ponteiro);
                sintsom ('BVBLKCRG');   {'Bloco carregado'}

            freemem (p, tamAloc);
        end;
end;

{-----------------------------}

PROCEDURE TRATACONTROLES;
var
c: char;
    x : byte;
    salva: integer;
    n: integer;
    sf: string;
Begin
    tecla := readkey;
    Case tecla of
    #15: Begin
            If ponteiro > 10  Then ponteiro :=ponteiro-10
            Else ponteiro :=3;

            px :=1;
            atualizaPorIndice;
//            sintclek;
          end;

    F1:    falaPalavra;

    CTLF1: begin
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

CTLF2: begin
c := '3';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('BIBLIVOX', 'DIRBIBLIVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

CTLF3: begin
c := '4';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('BIBLIVOX', 'DIRBIBLIVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

CTLF4: begin
c := '5';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('BIBLIVOX', 'DIRBIBLIVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        ^F: Begin
                While Not Keypressed  Do
                Begin
                    If ponteiro > TamanhoBiblia-5  Then Exit;
                    falalinha(false);
                    If px >= Length (texto[py])  Then
                        px :=1;
                    inc(ponteiro);
                    escrevetelatexto;
                    atualizaporindice;
                end;
                while Keypressed Do tecla := readkey;
                tecla :=#255;
             end;

    F2: begin FalaLivroAtual;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    F3: begin AchaVersiculo;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    F4: begin Paramsintese;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
{        msgbaixo ('BVFIMTXT', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
{        msgbaixo ('BVFIMTEX', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

    F9: begin  VaiparaMarca;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLF9: begin MarcaLivro;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    F5: buscaPalavra;
    CTLF5: buscaDeNovo;

    F6: begin VaiparaLivro;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    F7: begin VaiParaCapitulo;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    F8: FalaHora;

    CTLF8: FalaDia;

    F11: begin
begin
    sintFalaPont := not sintFalaPont;
    if sintFalaPont then
        fala ('BVPONACI')
    else
        fala ('BVPONDLG');
end;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
{        msgbaixo ('BVFIMTXT', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
{        msgbaixo ('BVFIMTEX', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

    CTLF11: begin
begin
    gravaAsProcuras := not gravaAsProcuras;
    if gravaAsProcuras then
        fala ('BVGRAVAN') {'Gravando as procuras'}
    else
        fala ('BVSEMGRA'); {'Sem gravar as procuras'}
end;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
{        msgbaixo ('BVFIMTXT', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
{        msgbaixo ('BVFIMTEX', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

    F12, CTLF12: buscaRebusca;

    CTLPGUP: begin LivroAnterior;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLPGDN: begin LivroPosterior;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLHOME: begin IniLivro;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLEND: begin FimLivro;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

DEL, CTLF7: begin NovoTestamento;
falaLivroAtual;
  sintsom('BVPODLER');
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

CTLINS, CTLF6, INS: begin AntigoTestamento;
falaLivroAtual;
  sintsom('BVPODLER');
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        CTLDIR:  begin
                     salva := px;
                     palavraDir (true);
                     n := px-salva;
                     sf := copy (texto[py], salva, n);
                     if trim (sf) = '' then
                         sintclek
                     else
                         sintetiza (sf);
                 end;
        CTLESQ:  begin
                     salva := px;
                     palavraEsq (true);
                     n := salva-px;
                     sf := copy (texto[py], px, n);
                     if trim (sf) = '' then
                         sintclek
                     else
                         sintetiza (sf);
                 end;

    DIR:  setadir;

    ESQ: setaesq;

    CIMA: Begin Setacima; atualizaporindice;
px :=1;
  buscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

    BAIX: begin Setabaixo;
px :=1;
  buscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

    #113: VoltaNumber;

    #114: AvancaNumber;

    HOME: Begin
            px := 1;
//            sintclek;
          end;

    TEND: Begin
            px := length( Trim ( texto [py]))+1;
//            sintclek;
          end;

    PGUP: begin voltaCapitulo;
py :=1;
px :=1;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    PGDN: begin pulaCapitulo;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    else  { of case }
            sintBip;
    end;
End;

{-----------------------------}

Procedure ProcessaLeitura;
var x : byte;

begin
  gotoxy(2,24); write(barraleitura);
  InicBloco;

  str(capituloatual, numlivro);
    tituloler :=nomelivros^[codlivro]+'-CAPTULO-'+numlivro;

    escreveTelaTexto;
                        sintetiza (texto [py]);
    repeat
            gotoxy (px, 09+py);
        tecla := readkey;
                Case tecla Of
                    { alt, ins, del, etc... }
                    #0: trataControles;

    ' ': begin
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< TamanhoBiblia-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('BVFIMBIB', 'Fim da Bblia !');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< TamanhoBiblia-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end
else
             end;

        'a','A': begin AjudaComandos;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        ^A: Begin
                                ponteiro := ponteiro + 15;
                                if ponteiro > tamanhobiblia-4 then
                                    begin
                                        ponteiro := tamanhobiblia-4;
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
//sintclek;
                                   end
                                else
//sintclek;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^S, 's', 'S': begin FalaLivroAtual;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^D, 'd', 'D': begin AchaVersiculo;
px :=1;
  buscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
end;

    'f', 'F': buscaPalavra;
    't', 'T': buscaPalavraBG;
    ^F: buscaDeNovo;
    ^T: buscaDeNovoBG;

    ^G, 'g', 'G': begin VaiparaLivro;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^H, 'h', 'H': begin VaiParaCapitulo;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

     'j', 'J': begin  VaiparaMarca;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^J: begin MarcaLivro;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                    'v', 'V': AvancaNumber;

                    ^V: begin FalaVersao;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                    ^M, 'm', 'M': begin Setabaixo;
px :=1;
  buscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
end;

                    'r', 'R': VoltaNumber;

        ^R: Begin
                                ponteiro := ponteiro - 15;
                                if ponteiro < 10 then
                                    begin
                                        ponteiro := 3;
        msgbaixo ('BVINITEX', 'Incio da Biblia!');
//sintclek;
                                    end
                                else
//sintclek;
py :=1;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        ^L, 'l', 'L': begin Poslinha;
if not keypressed then
posColuna;
end;

        ^K, 'k', 'K': begin PosColuna;
if not keypressed then
posLinha;
end;

        ^U, 'u', 'U': Begin
                                ponteiro := ponteiro - 10;
                                if ponteiro < 10 then
                                    begin
                                        ponteiro := 3;
        msgbaixo ('BVINITEX', 'Incio da Biblia!');
//sintclek;
                                    end
                                else
px :=1;
  buscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
//sintclek;
py :=1;
//px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
end;

        ^N, 'n', 'N': Begin
                                ponteiro := ponteiro + 10;
                                if ponteiro > tamanhobiblia-7 then
                                    begin
                                        ponteiro := tamanhobiblia-7;
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
                                    end
                                else
px :=1;
  buscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
end;

    'x', 'X': begin pulaCapitulo;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^E, 'e', 'E': begin voltaCapitulo;
py :=1;
px :=1;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

       ^C, 'c', 'C' : jogaAreaTransf (true);

    ^Z, 'z', 'Z': begin LivroPosterior;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^Q, 'q', 'Q': begin LivroAnterior;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'/', '?': begin NovoTestamento;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'.', '>': begin FimLivro;
  sintsom('BVCAP');
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^I, 'i', 'I': begin InicioCapitulo;
        msgbaixo('BVINICAP', 'Incio do captulo');
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ',', '<': begin FimCapitulo;
        msgbaixo('BVFIMCAP', 'Fim do captulo');
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'p', 'P': begin AntigoTestamento;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

^W, 'w', 'W': begin LivroSalmos;
falaLivroAtual1;
  sintsom('BVPODLER');
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

^Y, 'y', 'Y': begin LivroProverbios;
falaLivroAtual1;
  sintsom('BVPODLER');
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    'o', 'O': begin IniLivro;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'[', '{': begin IniBiblia;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

']', '}': begin FimBiblia;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        ^B, 'B', 'b': tratabloco;

                    { escape }
                    #27: ;
                    ^X: begin
delay (3);
    SintFim;
    doneWinCrt;
end;

        else { case }
               sintBip;
        End;

        str(capituloatual, numlivro);
    tituloler :=nomelivros^[codlivro]+'-CAPTULO-'+numlivro;
        escreveTelatexto;

    Until tecla = #27;   { escape }
  InicBloco;
  msgbaixo('BVFIMLEI', 'Livro fechado...');
end;

Procedure LeituraInfo;
var lendoContinuo: boolean;

        procedure processaContr;
var c: char;
    x : byte;
    salva: integer;
    n: integer;
    sf: string;
        Begin
            tecla := readkey;
            Case tecla of

                F1: falaPalavra;

    CTLF1: begin
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
end;

CTLF2: begin
c := '3';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('BIBLIVOX', 'DIRBIBLIVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
end;

CTLF3: begin
c := '4';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('BIBLIVOX', 'DIRBIBLIVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
end;

CTLF4: begin
c := '5';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('BIBLIVOX', 'DIRBIBLIVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
end;

                ^F: begin
                        While Not Keypressed  Do
                        Begin
                          If ponteiro > TamanhoInfo-5  Then Exit;
                          falalinha(false);
                          If px >= Length (texto[py])  Then px :=1;
                          inc(ponteiro);
                          escrevetelatexto;
                        end;
                        while Keypressed  Do tecla := readkey;
                        tecla :=#255;
                     end;

                F4: begin Paramsintese;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

                F5: buscaCadeia;

                CTLF5: buscaNovamente;

                F8: FalaHora;

                CTLF8: FalaDia;

    F11: begin
begin
    sintFalaPont := not sintFalaPont;
    if sintFalaPont then
        fala ('BVPONACI')
    else
        fala ('BVPONDLG');
end;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

                INS:
 begin
  ponteiro := 1;
py :=1;
px :=1;
        msgbaixo ('BVINITEX', 'Incio da Biblia!');
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        CTLDIR:  begin
                     salva := px;
                     palavraDir (true);
                     n := px-salva;
                     sf := copy (texto[py], salva, n);
                     if trim (sf) = '' then
                         sintclek
                     else
                         sintetiza (sf);
                 end;
        CTLESQ:  begin
                     salva := px;
                     palavraEsq (true);
                     n := salva-px;
                     sf := copy (texto[py], px, n);
                     if trim (sf) = '' then
                         sintclek
                     else
                         sintetiza (sf);
                 end;

                DIR: setadir;

                ESQ: setaesq;

                CIMA: begin Setacima1;
if not keypressed then
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

                BAIX: begin Setabaixo1;
if not keypressed then
px :=1;
  buscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (buscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

                HOME: Begin
                     px := 1;
//                    sintclek;
                    end;

                TEND: Begin
                    px := length (trim ( texto [py]))+1;
                    sintbip;
                        end;

        PGUP: begin PageCima;
py :=1;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        PGDN: begin
                                ponteiro := ponteiro + 10;
                                if ponteiro > TamanhoInfo-2 then
                                    begin
                                        ponteiro := TamanhoInfo-2;
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
//sintclek;
end
                                else
//sintclek;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

CTLPGUP, CTLHOME:
 begin
py :=1;
px :=1;
  ponteiro := 1;
        msgbaixo ('BVINITEX', 'Incio do texto!');
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

CTLPGDN, CTLEND, DEL:
 begin
  ponteiro := TamanhoInfo-2;
py :=1;
px :=1;
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                else  { of case }
                    sintBip;
            end;
        End;


begin
    TituloLer := '                    - INFORMAES SOBRE A BBLIA -                     ';
    gotoxy(2,24); write(barrainfo);
    escreveTelaTexto;
                        sintetiza (texto[py]);
    repeat
            gotoxy (px, 09+py);
        tecla := readkey;
                Case tecla Of
                    #0:  processaContr;


    'v', 'V': begin SetaBaixo1;
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
px :=1;
end;

                    ^V: begin FalaVersao;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^R, 'r', 'R': begin SetaCima1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
px :=1;
end;

                    ^L, 'l', 'L': begin PosLinha1;
PosColuna;
end;

                    ^K, 'k', 'K': begin PosColuna;
PosLinha1;
end;

        ^U, 'u', 'U': Begin
                                ponteiro := ponteiro - 10;
                                if ponteiro < 10 then
                                    begin
                                        ponteiro := 1;
        msgbaixo ('BVINITEX', 'Incio da Biblia!');
//sintclek;
                                    end
                                else
//sintclek;
py :=1;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
px :=1;
end;

^N, 'n', 'N': begin
                                ponteiro := ponteiro + 10;
                                if ponteiro > TamanhoInfo-2 then
                                    begin
                                        ponteiro := TamanhoInfo-2;
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
//sintclek;
                                    end
                                else
//sintclek;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
px :=1;
end;

                    ^M, 'm', 'M': begin Setabaixo;
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ' ': begin
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
end;

      ^A, 'a', 'A':   sintsom('BVLEINFO');

        ^B, 'B', 'b': tratablocoInfo;

    'f', 'F', 't', 'T': buscaCadeia;
    ^F, ^T: buscanovamente;

^O, 'O', 'o':
 begin
py :=1;
px :=1;
  ponteiro := 1;
        msgbaixo ('BVINITEX', 'Incio do texto!');
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

^P, 'p', 'P':
 begin
py :=1;
px :=1;
  ponteiro := 1;
        msgbaixo ('BVINITEX', 'Incio da Biblia!');
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'/', '?':
 begin
  ponteiro := TamanhoInfo-2;
py :=1;
px :=1;
        msgbaixo ('BVFIMTEX', 'Fim do Texto!');
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                    { escape }
                    #27: ;
                    ^X: begin
    SintFim;
    doneWinCrt;
end;

                else { case }
                       sintBip;
                End;

                escreveTelatexto;

    Until tecla = #27;   { escape }
  InicBloco;
  msgbaixo('BVFIMLEI', 'Livro fechado...');
end;

end.
